<?php
/* vim: set et ts=4 sw=4 sts=4 ai: */
// +----------------------------------------------------------------------+
// | Main script - handles logic                                          |
// +----------------------------------------------------------------------+
// | @version $Revision: 1.24 $
// +----------------------------------------------------------------------+

define("OCHIBA_VERSION","1.1");
require("conf.php");
require(INCLUDES_DIR . "/functions.php");
#require(INCLUDES_DIR . "/custom.php");
require(INCLUDES_DIR . "/page.php");
$page = new Page();

//----- Check for bans here to prevent banned users from viewing anything
//      This has serious performances consequences, obviously. Another place
//      You can call this is on posts - banned ips can view but not post (-V)
if(isBanned()) {
    $tmpl = new HTML_Template_IT(TEMPLATE_DIR,array("use_preg"=>false));
    $tmpl->loadTemplateFile("banned.tmpl",true,false);
    $tmpl->show();
    exit;
}

//----- Get $path. Should be a letter, if a category filter is requested
//		or a number, if a specific image is requested. Then there are
//		special action keywords (post,comment,delete)

$path_parts = explode("/",$_SERVER["PATH_INFO"]);
$path = $path_parts[1];
$page_num = is_numeric($_GET["p"]) && $_GET["p"]>0 ? $_GET["p"] : 1;
switch ($path) {

    case "view":

        if(is_numeric(FEATURE_CACHE_VIEWS)) {
            $x = 60 * 60 * 24 * FEATURE_CACHE_VIEWS;
            $h = "Expires: " . gmdate("D, d M Y H:i:s", time() + $x) . " GMT";
            header("Cache-Control: must-revalidate");
            header($h);
        }

        $result = viewImage($path_parts[2] . "-" . $path_parts[3]);
        exit;
        break;

    case "admin":
    case "mod":
        session_start();
        include(INCLUDES_DIR . "/${path}.php");
        setCategories();
        break;

	case "comment":
	case "post":
		session_start();
        $page->meta(POPUP_CSS);
        include(INCLUDES_DIR . "/${path}.php");
		break;

	case "delete":
    case "delcomment":
	case "modify":
	case "category":
	case "edit":
    case "move":
	case "ban":
    case "flushcache":
    case "deletethread":
        $page->meta(POPUP_CSS);
        include(INCLUDES_DIR . "/${path}.php");
		break;
		
    case "prefs":
        $page->meta(POPUP_CSS);
        $page->meta('<script type="text/javascript" src="' . ROOT . '/js/prefs.js"></script>');
        include(INCLUDES_DIR . "/prefs.php");
        break;

	case "verify":
        include(INCLUDES_DIR . "/verification.php");
        exit;
		break;

    case "rss":
        if(FEATURE_RSS===true) {
            include(INCLUDES_DIR . "/rss.php");
        }
        break;
		
    case "search":
        // If no additiona path_parts, drawing the search form;
        if(count($path_parts)>2) {
            include(INCLUDES_DIR . "/images.php");
            setCategories();

        // else doing the lookup
        } else {
            $page->meta(POPUP_CSS);
            include(INCLUDES_DIR . "/search.php");
        }
        break;

    case "stats":
        
        // Display some site stats
        if(FEATURE_STATS===true) {
            //----- This page caches;
            $page->setCache(FEATURE_CACHE,$path);
            $page->checkCache(__FILE__,$path);
            include(INCLUDES_DIR . "/stats.php");

            // Also, let image.php draw up top 10
            include(INCLUDES_DIR . "/images.php");
            setCategories();
        }
        break;

    //----- The index (home) page
	case "":
        $tmpl = new HTML_Template_IT(TEMPLATE_DIR,array("use_preg"=>false));
        $tmpl->loadTemplateFile("home.tmpl",true,false);
		$tmpl->show();
        setCategories();
		break;

    //----- If none of the above caught it, look for image categories
	default:
        include(INCLUDES_DIR . "/images.php");
        setCategories();
		break;
}

$page->display();
?>
